/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern8 (x3, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern8 (x3, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!nvptx_register_operand (x5, E_BImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x5;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          return 0;

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[1] = x5;
          x7 = XEXP (x2, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern12 (x2, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (pattern12 (x2, 
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern12 (x2, 
E_DImode) != 0)
                return -1;
              return 3;

            case E_SFmode:
              if (pattern12 (x2, 
E_SFmode) != 0)
                return -1;
              return 4;

            case E_DFmode:
              if (pattern12 (x2, 
E_DFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 21
          || GET_MODE (x5) != E_BImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      operands[0] = x10;
      if (!nvptx_register_operand (operands[0], E_BImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      return 6;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  if (!nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!nvptx_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!nvptx_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!nvptx_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern57 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern57 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern57 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    case E_SFmode:
      if (pattern57 (x1, 
E_SFmode) != 0)
        return -1;
      return 3;

    case E_DFmode:
      if (pattern57 (x1, 
E_DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern70 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern70 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      operands[2] = x1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[0], E_SImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 193; /* call_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[0], E_DImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 194; /* call_insn_di */

        default:
          return -1;
        }

    case SET:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CALL)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_QImode)
        return -1;
      operands[3] = x1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nvptx_register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!call_insn_operand (operands[1], E_SImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode))
            return -1;
          return 195; /* call_value_insn_si */

        case E_DImode:
          if (!call_insn_operand (operands[1], E_DImode)
              || !
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode))
            return -1;
          return 196; /* call_value_insn_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 0:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!nvptx_register_operand (operands[0], E_QImode)
                  || GET_MODE (x4) != E_QImode)
                return -1;
              return 434; /* *p load_arg_regqi */

            case E_HImode:
              if (!nvptx_register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode)
                return -1;
              return 435; /* *p load_arg_reghi */

            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              return 436; /* *p load_arg_regsi */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 437; /* *p load_arg_regdi */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode)
                return -1;
              return 438; /* *p load_arg_regsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 439; /* *p load_arg_regdf */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1310 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 640; /* *p sinsf2 */

        case 5:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1317 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 641; /* *p cossf2 */

        case 2:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SFmode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_SFmode)
              || !
#line 1324 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
            return -1;
          return 642; /* *p log2sf2 */

        case 3:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1331 "../../gcc/config/nvptx/nvptx.md"
(flag_unsafe_math_optimizations))
                return -1;
              return 643; /* *p exp2sf2 */

            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x4) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1400 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 652; /* *p exp2hf2 */

            default:
              return -1;
            }

        case 7:
          if (GET_MODE (x4) != E_BImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_BImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nvptx_register_operand (operands[1], E_SFmode))
                return -1;
              return 644; /* *p setcc_isinfsf */

            case E_DFmode:
              if (!nvptx_register_operand (operands[1], E_DFmode))
                return -1;
              return 645; /* *p setcc_isinfdf */

            default:
              return -1;
            }

        case 6:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (!nvptx_register_operand (operands[0], E_HFmode)
                  || GET_MODE (x4) != E_HFmode
                  || !nvptx_register_operand (operands[1], E_HFmode)
                  || !
#line 1407 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 653; /* *p tanhhf2 */

            case E_SFmode:
              if (!nvptx_register_operand (operands[0], E_SFmode)
                  || GET_MODE (x4) != E_SFmode
                  || !nvptx_register_operand (operands[1], E_SFmode)
                  || !
#line 1407 "../../gcc/config/nvptx/nvptx.md"
(TARGET_SM75 && flag_unsafe_math_optimizations))
                return -1;
              return 654; /* *p tanhsf2 */

            default:
              return -1;
            }

        case 8:
          switch (pattern47 (x1))
            {
            case 0:
              return 675; /* *p floorsf2 */

            case 1:
              return 679; /* *p floordf2 */

            case 2:
              return 683; /* *p lfloorsfsi2 */

            case 3:
              return 685; /* *p lfloordfsi2 */

            case 4:
              return 687; /* *p lfloorsfdi2 */

            case 5:
              return 689; /* *p lfloordfdi2 */

            default:
              return -1;
            }

        case 9:
          switch (pattern48 (x1))
            {
            case 0:
              return 676; /* *p btruncsf2 */

            case 1:
              return 680; /* *p btruncdf2 */

            default:
              return -1;
            }

        case 10:
          switch (pattern47 (x1))
            {
            case 0:
              return 677; /* *p ceilsf2 */

            case 1:
              return 681; /* *p ceildf2 */

            case 2:
              return 684; /* *p lceilsfsi2 */

            case 3:
              return 686; /* *p lceildfsi2 */

            case 4:
              return 688; /* *p lceilsfdi2 */

            case 5:
              return 690; /* *p lceildfdi2 */

            default:
              return -1;
            }

        case 11:
          switch (pattern48 (x1))
            {
            case 0:
              return 678; /* *p nearbyintsf2 */

            case 1:
              return 682; /* *p nearbyintdf2 */

            default:
              return -1;
            }

        case 14:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !(
#line 1757 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 710; /* *p nvptx_stacksave_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 1757 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 711; /* *p nvptx_stacksave_di */

            default:
              return -1;
            }

        case 15:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nvptx_register_operand (operands[1], E_SImode)
                  || !(
#line 1790 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == SImode)))
                return -1;
              return 712; /* *p nvptx_stackrestore_si */

            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !nvptx_register_operand (operands[1], E_DImode)
                  || !(
#line 1790 "../../gcc/config/nvptx/nvptx.md"
(TARGET_PTX_7_3
   && TARGET_SM52) && 
#line 228 "../../gcc/config/nvptx/nvptx.md"
(Pmode == DImode)))
                return -1;
              return 713; /* *p nvptx_stackrestore_di */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          return 715; /* *p oacc_dim_size */

        case 18:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x7 = XEXP (x5, 1);
          operands[4] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          operands[1] = x8;
          if (!nvptx_register_operand (operands[1], E_BImode))
            return -1;
          return 719; /* *p nvptx_vote_ballot */

        case 19:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!nvptx_register_operand (operands[0], E_SImode))
            return -1;
          return 724; /* *p omp_simt_lane */

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 1);
      operands[5] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      switch (XINT (x4, 1))
        {
        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern64 (x4, 
E_SFmode) != 0)
                return -1;
              return 628; /* *p copysignsf3 */

            case E_DFmode:
              if (pattern64 (x4, 
E_DFmode) != 0)
                return -1;
              return 629; /* *p copysigndf3 */

            default:
              return -1;
            }

        case 17:
          if (!nvptx_register_operand (operands[1], E_SImode)
              || !nvptx_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              return 727; /* *p packsidi2 */

            case E_DFmode:
              if (!nvptx_register_operand (operands[0], E_DFmode)
                  || GET_MODE (x4) != E_DFmode)
                return -1;
              return 728; /* *p packsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x4, 1) != 20)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x5, 1);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!nvptx_nonmemory_operand (operands[2], E_SImode))
        return -1;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nvptx_register_operand (operands[1], E_SImode))
            return -1;
          return 717; /* *p nvptx_shufflesi */

        case E_SFmode:
          if (!nvptx_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !nvptx_register_operand (operands[1], E_SFmode))
            return -1;
          return 718; /* *p nvptx_shufflesf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
