/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern0 (x3, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern0 (x3, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!nvptx_register_operand (operands[1], E_BImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!nvptx_register_operand (operands[2], E_BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern14 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern14 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern14 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[5] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern25 (x7, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern25 (x7, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern25 (x7, 
E_DImode) != 0)
        return -1;
      return 2;

    case E_BImode:
      if (pattern27 (x7, 
E_BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nvptx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nvptx_register_operand (operands[1], i1)
      || !nvptx_nonmemory_operand (operands[2], i1)
      || !nvptx_nonmemory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nvptx_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nvptx_register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nvptx_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nvptx_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!nvptx_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nvptx_register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!nvptx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !nvptx_register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_DFmode:
      if (!nvptx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !nvptx_register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_HFmode:
      if (!nvptx_register_operand (operands[0], E_HFmode)
          || GET_MODE (x1) != E_HFmode
          || !nvptx_register_operand (operands[1], E_HFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (nvptx_register_operand (operands[1], E_BImode))
        {
          switch (GET_CODE (x3))
            {
            case EQ:
              switch (pattern20 (x2))
                {
                case 0:
                  return 171; /* *selphi_neg_eq */

                case 1:
                  return 173; /* *selpsi_neg_eq */

                case 2:
                  return 175; /* *selpdi_neg_eq */

                default:
                  break;
                }
              break;

            case NE:
              switch (pattern20 (x2))
                {
                case 0:
                  return 172; /* *selphi_neg_ne */

                case 1:
                  return 174; /* *selpsi_neg_ne */

                case 2:
                  return 176; /* *selpdi_neg_ne */

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
    }
  operands[1] = x3;
  if (!nvptx_float_comparison_operator (operands[1], E_SImode)
      || !nvptx_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  operands[3] = x4;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!nvptx_register_operand (operands[2], E_SFmode)
          || !nvptx_nonmemory_operand (operands[3], E_SFmode))
        return -1;
      return 186; /* *setcc_intsf */

    case E_DFmode:
      if (!nvptx_register_operand (operands[2], E_DFmode)
          || !nvptx_nonmemory_operand (operands[3], E_DFmode))
        return -1;
      return 187; /* *setcc_intdf */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nvptx_register_operand (operands[1], E_HImode))
                return -1;
              return 512; /* *p *cnothi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 569; /* *p *setcchi_from_not_bi */

            default:
              return -1;
            }

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nvptx_register_operand (operands[1], E_SImode))
                return -1;
              return 513; /* *p *cnotsi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 570; /* *p *setccsi_from_not_bi */

            default:
              return -1;
            }

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nvptx_register_operand (operands[1], E_DImode))
                return -1;
              return 514; /* *p *cnotdi2 */

            case E_BImode:
              if (!nvptx_register_operand (operands[1], E_BImode))
                return -1;
              return 571; /* *p *setccdi_from_not_bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      if (!nvptx_register_operand (operands[1], E_BImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nvptx_register_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode)
            return -1;
          return 565; /* *p setccqi_from_bi */

        case E_HImode:
          if (!nvptx_register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode)
            return -1;
          return 566; /* *p setcchi_from_bi */

        case E_SImode:
          if (!nvptx_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          return 567; /* *p setccsi_from_bi */

        case E_DImode:
          if (!nvptx_register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          return 568; /* *p setccdi_from_bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
